diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 5165626fb..f161b7d88 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.entity.player;
 
-import com.mojang.nbt.tags.CompoundTag;
-import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.*;
 import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.block.entity.*;
 import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.*;
 import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.animal.MobWolf;
@@ -41,6 +41,7 @@ import net.minecraft.core.item.tool.ItemToolSword;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.menu.MenuAbstract;
@@ -85,7 +86,7 @@ public abstract class Player
     public final @Nullable ItemStack @NotNull [] oldArmorInventory = new ItemStack[4]; // Last tick's armor inventory, used for playing equip sounds at the right time.
     public MenuAbstract inventorySlots;
     public MenuAbstract craftingInventory;
-    public Gamemode gamemode = Gamemode.survival;
+    public Gamemode gamemode = Gamemodes.SURVIVAL;
     //    public byte userType;
     public int score;
     public List<String> messageHistory = new ArrayList<>();
@@ -140,7 +141,7 @@ public abstract class Player
         this.timeUntilPortal = 20;
         this.inPortal = false;
         this.bobberEntity = null;
-        this.inventorySlots = new MenuInventory(this.inventory, !world.isClientSide);
+        this.inventorySlots = new MenuInventory(this.inventory);
         this.craftingInventory = this.inventorySlots;
         TilePos spawnPoint = world.getSpawnPoint();
         moveTo((double) spawnPoint.x + 0.5D, spawnPoint.y + 1, (double) spawnPoint.z + 0.5D, 0.0F, 0.0F);
@@ -453,8 +454,8 @@ public abstract class Player
 
     @Override
     public void onDeath(Entity entityKilledBy) {
-        if (getGamemode().isPermaDeath()) {
-            setGamemode(Gamemode.spectator);
+        if (getGamemode().hasPermaDeath()) {
+            setGamemode(Gamemodes.SPECTATOR);
         }
         super.onDeath(entityKilledBy);
         setSize(0.2F, 0.2F);
@@ -462,16 +463,16 @@ public abstract class Player
         this.lastDeathPoint = new TilePos(this);
         this.yd = 0.1d;
         if (UUID_MAK.equals(this.uuid) || this.username.equals("MaggAndGeez")) {
-            dropPlayerItemWithRandomChoice(new ItemStack(Items.AMMO_FIREBALL, 1), true);
+            dropItem(new ItemStack(Items.AMMO_FIREBALL, 1), true);
         } else if (UUID_JONK.equals(this.uuid) || this.username.equals("jonkadelic")) {
-            dropPlayerItemWithRandomChoice(new ItemStack(Items.FOOD_COOKIE, 1), true);
+            dropItem(new ItemStack(Items.FOOD_COOKIE, 1), true);
         } else if (UUID_SHIGN.equals(this.uuid) || this.username.equals("ShignBright")) {
-            dropPlayerItemWithRandomChoice(new ItemStack(Items.SIGN_PAINTED, 1, DyeColor.PINK.itemMeta), true);
+            dropItem(new ItemStack(Items.SIGN_PAINTED, 1, DyeColor.PINK.itemMeta), true);
         } else if ((UUID_MELON.equals(this.uuid) || this.username.equals("MelonMojito")) || (UUID_WATERMELON.equals(this.uuid) || this.username.equals("WatermelonMojito"))) {
             ItemStack melon = new ItemStack(Blocks.PUMPKIN, 1, this.random.nextInt(Short.MAX_VALUE / 2) + 1);
             melon.setCustomName("Melon");
             melon.setCustomColor((byte) TextFormatting.LIME.id);
-            dropPlayerItemWithRandomChoice(melon, true);
+            dropItem(melon, true);
         }
 
         if (!this.world.getGameRuleValue(GameRules.KEEP_INVENTORY)) {
@@ -614,11 +615,11 @@ public abstract class Player
     }
 
     public void dropCurrentItem(boolean dropFullStack) {
-        dropPlayerItemWithRandomChoice(this.inventory.removeItem(this.inventory.getCurrentItemIndex(), dropFullStack ? 64 : 1), false);
+        dropItem(this.inventory.removeItem(this.inventory.getCurrentSlot(), dropFullStack ? 64 : 1), false);
     }
 
     public void dropPlayerItem(ItemStack itemstack) {
-        dropPlayerItemWithRandomChoice(itemstack, false);
+        dropItem(itemstack, false);
     }
 
     public void setHotbarOffset(int offset) {
@@ -665,34 +666,38 @@ public abstract class Player
         super.push(entity);
     }
 
-    public void dropPlayerItemWithRandomChoice(ItemStack itemstack, boolean flag) {
-        if (!getGamemode().canInteract()) return;
-        if (itemstack == null) {
+    public void dropItem(final @Nullable ItemStack stack, final boolean randomDirection) {
+        if (!this.getGamemode().canInteract()) return;
+        if (stack == null) {
             return;
         }
-        EntityItem entityitem = new EntityItem(this.world, this.x, (this.y - 0.30000001192092896D) + (double) this.getHeadHeight(), this.z, itemstack);
-        entityitem.pickupDelay = 40;
-        float f = 0.1F;
-        if (flag) {
-            float f2 = this.random.nextFloat() * 0.5F;
-            float f4 = this.random.nextFloat() * MathHelper.PI * 2.0F;
-            entityitem.xd = -MathHelper.sin(f4) * f2;
-            entityitem.zd = MathHelper.cos(f4) * f2;
-            entityitem.yd = 0.2D;
+
+        final @NotNull EntityItem itemEntity = new EntityItem(this.world, this.x, (this.y - 0.3) + (double) this.getHeadHeight(), this.z, stack);
+        itemEntity.pickupDelay = 40;
+
+        if (randomDirection) {
+            final float speed = this.random.nextFloat() * 0.5F;
+            final float angle = this.random.nextFloat() * MathHelper.PI * 2.0F;
+
+            itemEntity.xd = -MathHelper.sin(angle) * speed;
+            itemEntity.zd = MathHelper.cos(angle) * speed;
+            itemEntity.yd = 0.2D;
         } else {
-            float f1 = 0.3F;
-            entityitem.xd = -MathHelper.sin((this.yRot / 180F) * MathHelper.PI) * MathHelper.cos((this.xRot / 180F) * MathHelper.PI) * f1;
-            entityitem.zd = MathHelper.cos((this.yRot / 180F) * MathHelper.PI) * MathHelper.cos((this.xRot / 180F) * MathHelper.PI) * f1;
-            entityitem.yd = -MathHelper.sin((this.xRot / 180F) * MathHelper.PI) * f1 + 0.1F;
-            f1 = 0.02F;
-            float f3 = this.random.nextFloat() * MathHelper.PI * 2.0F;
-            f1 *= this.random.nextFloat();
-            entityitem.xd += java.lang.Math.cos(f3) * (double) f1;
-            entityitem.yd += (this.random.nextFloat() - this.random.nextFloat()) * 0.1F;
-            entityitem.zd += java.lang.Math.sin(f3) * (double) f1;
+            float speed = 0.3F;
+            itemEntity.xd = -MathHelper.sin((this.yRot / 180F) * MathHelper.PI) * MathHelper.cos((this.xRot / 180F) * MathHelper.PI) * speed;
+            itemEntity.yd = -MathHelper.sin((this.xRot / 180F) * MathHelper.PI) * speed + 0.1F;
+            itemEntity.zd = MathHelper.cos((this.yRot / 180F) * MathHelper.PI) * MathHelper.cos((this.xRot / 180F) * MathHelper.PI) * speed;
+
+            speed = 0.02F;
+            final float jitterAngle = this.random.nextFloat() * MathHelper.PI * 2.0F;
+            speed *= this.random.nextFloat();
+            itemEntity.xd += Math.cos(jitterAngle) * speed;
+            itemEntity.yd += (this.random.nextFloat() - this.random.nextFloat()) * 0.1F;
+            itemEntity.zd += Math.sin(jitterAngle) * speed;
         }
-        joinEntityItemWithWorld(entityitem);
-        addStat(StatList.dropStat, 1);
+
+        this.joinEntityItemWithWorld(itemEntity);
+        this.addStat(StatList.dropStat, 1);
     }
 
     protected void joinEntityItemWithWorld(EntityItem entityitem) {
@@ -700,22 +705,40 @@ public abstract class Player
     }
 
     public float getCurrentPlayerStrVsBlock(@NotNull Block<?> block) {
-        float f = this.inventory.getStrVsBlock(block);
+        final @Nullable ItemStack currentItem = this.inventory.getCurrentItem();
+        float str;
+        if (currentItem != null) {
+            str = currentItem.getStrVsBlock(block);
+        } else {
+            str = 1.0f;
+        }
         float defaultBreakSpeed = (this.inventory.getCurrentItem() != null && this.inventory.getCurrentItem().getItem() instanceof ItemToolSword) ? 1.51f : 1.01f;
-        if (this.getGamemode().doesRequireToolToBreak() && f <= defaultBreakSpeed)
+        if (this.getGamemode().isProperToolNeededToMine() && str <= defaultBreakSpeed)
             return 0; // Requires to break and not effective against block
         if (isUnderLiquid(Materials.WATER)) {
-            f /= 5F;
+            str /= 5F;
         }
         if (!this.onGround && !canClimb() && this.vehicle == null) {
-            f /= 5F;
+            str /= 5F;
         }
-        return f;
+        return str;
     }
 
-    public boolean canHarvestBlock(Block<?> block) {
-        if (block == null) return false;
-        return this.inventory.canHarvestBlock(block);
+    public boolean canHarvestBlock(final @Nullable Block<?> block) {
+        if (block == null) {
+            return false;
+        }
+        if (block.getMaterial().isAlwaysDestroyable()) {
+            return true;
+        }
+
+        final @Nullable ItemStack stack = this.inventory.getCurrentItem();
+
+        if (stack != null) {
+            return stack.canHarvestBlock(this, block);
+        } else {
+            return false;
+        }
     }
 
     @Override
@@ -723,19 +746,33 @@ public abstract class Player
         super.readAdditionalSaveData(tag);
         this.nickname = this.nickname.replace(" ", "");
         ListTag nbttaglist = tag.getList("Inventory");
-        this.inventory.readFromNBT(nbttaglist);
+        this.inventory.load(nbttaglist);
 
         System.arraycopy(this.inventory.armorInventory, 0, this.oldArmorInventory, 0, this.oldArmorInventory.length);
 
-        this.inventory.setCurrentItemIndex(tag.getIntegerOrDefault("CurrentItem", this.inventory.getCurrentItemIndex()), true);
+        this.inventory.setCurrentSlot(tag.getIntegerOrDefault("CurrentItem", this.inventory.getCurrentSlot()), true);
         this.inventory.setHotbarOffset(tag.getIntegerOrDefault("HotbarOffset", this.inventory.getHotbarOffset()), true);
         int dim = tag.getInteger("Dimension");
         if (dim == -1) dim = 1;
         this.dimension = dim;
         this.sleeping = tag.getBoolean("Sleeping");
         this.sleepTimer = tag.getShort("SleepTimer");
-        setGamemodeOnLogin(Gamemode.gamemodesList[tag.getInteger("Gamemode")]);
-        this.noPhysics = tag.getBoolean("Noclip") && this.gamemode.canPlayerFly();
+        final @Nullable Tag<?> gamemodeTag = tag.getTag("Gamemode");
+        if (gamemodeTag != null) {
+            final @Nullable Gamemode gamemode;
+            if (gamemodeTag instanceof final @NotNull StringTag stringTag) {
+                gamemode = Registries.GAMEMODES.getItem(stringTag.getValue());
+            } else if (gamemodeTag instanceof final @NotNull IntTag intTag) {
+                gamemode = Gamemodes.getGamemodeByLegacyId(intTag.getValue());
+            } else {
+                gamemode = null;
+            }
+
+            this.setGamemodeOnLogin(Objects.requireNonNullElse(gamemode, Gamemodes.SURVIVAL));
+        } else {
+            this.setGamemodeOnLogin(Gamemodes.SURVIVAL);
+        }
+        this.noPhysics = tag.getBoolean("Noclip") && this.gamemode.hasPlayerFlight();
         this.sneaking = tag.getBoolean("Sneaking");
         if (this.sleeping) {
             this.bedTilePos = new TilePos(this);
@@ -756,14 +793,14 @@ public abstract class Player
     @Override
     public void addAdditionalSaveData(@NotNull CompoundTag tag) {
         super.addAdditionalSaveData(tag);
-        tag.put("Inventory", this.inventory.writeToNBT(new ListTag()));
-        tag.putInt("CurrentItem", this.inventory.getCurrentItemIndex());
+        tag.put("Inventory", this.inventory.save(new ListTag()));
+        tag.putInt("CurrentItem", this.inventory.getCurrentSlot());
         tag.putInt("HotbarOffset", this.inventory.getHotbarOffset());
         tag.putInt("Dimension", this.dimension);
         tag.putBoolean("Sleeping", this.sleeping);
         tag.putShort("SleepTimer", (short) this.sleepTimer);
-        tag.putInt("Gamemode", this.gamemode.getId());
-        tag.putBoolean("Noclip", this.noPhysics && this.gamemode.canPlayerFly());
+        tag.putString("Gamemode", this.gamemode.getId());
+        tag.putBoolean("Noclip", this.noPhysics && this.gamemode.hasPlayerFlight());
         tag.putBoolean("Sneaking", this.sneaking);
         if (this.playerSpawnPoint != null) {
             tag.putInt("SpawnX", this.playerSpawnPoint.x);
@@ -839,7 +876,7 @@ public abstract class Player
         if (getHealth() <= 0) {
             return false;
         }
-        if (this.gamemode.isPlayerInvulnerable()) {
+        if (this.gamemode.hasInvulnerablePlayer()) {
             return false;
         }
         if (isPlayerSleeping() && !this.world.isClientSide) {
@@ -998,7 +1035,7 @@ public abstract class Player
     }
 
     public void destroyCurrentEquippedItem() {
-        this.inventory.setItem(this.inventory.getCurrentItemIndex(), null);
+        this.inventory.setItem(this.inventory.getCurrentSlot(), null);
     }
 
     @Override
@@ -1013,12 +1050,18 @@ public abstract class Player
 
     public void attackTargetEntityWithCurrentItem(@NotNull Entity entity) {
         if (!getGamemode().canInteract()) return;
-        int i = this.inventory.getDamageVsEntity(entity);
-        if (i > 0) {
+
+        int damage = 1;
+        final @Nullable ItemStack currentItem = this.inventory.getCurrentItem();
+        if (currentItem != null) {
+            damage = currentItem.getDamageVsEntity(entity);
+        }
+
+        if (damage > 0) {
             if (this.yd < 0.0D) {
-                i++;
+                damage++;
             }
-            entity.hurt(this, i, DamageType.COMBAT);
+            entity.hurt(this, damage, DamageType.COMBAT);
             ItemStack itemstack = getCurrentEquippedItem();
             if (itemstack != null && (entity instanceof Mob)) {
                 itemstack.hitEntity((Mob) entity, this);
@@ -1030,7 +1073,7 @@ public abstract class Player
                 if (entity.isAlive()) {
                     alertWolves((Mob) entity, true);
                 }
-                addStat(StatList.damageDealtStat, i);
+                addStat(StatList.damageDealtStat, damage);
             }
         }
         addStat(StatList.mobEncounterStats.get(entity.getDispatcherId()), 1);
@@ -1041,9 +1084,6 @@ public abstract class Player
 
     public abstract void animate4();
 
-    public void onItemStackChanged(ItemStack itemstack) {
-    }
-
     @Override
     public void remove() {
         super.remove();
@@ -1254,7 +1294,7 @@ public abstract class Player
 
     @Override
     public void setHeldItem(@Nullable ItemStack item) {
-        this.inventory.setCurrentItem(item, true);
+        this.inventory.setCurrentItem(item);
     }
 
     public void updateCreativeInventory(int page, String searchText) {
@@ -1380,7 +1420,7 @@ public abstract class Player
 
     @Override
     public boolean canBreatheUnderwater() {
-        return this.gamemode.isPlayerInvulnerable();
+        return this.gamemode.hasInvulnerablePlayer();
     }
 
     public @NotNull Gamemode getGamemode() {
@@ -1391,21 +1431,21 @@ public abstract class Player
     public void setGamemodeOnLogin(Gamemode gamemode) {
         this.gamemode = gamemode;
 
-        MenuInventory newContainer = gamemode.getContainer(this.inventory, !this.world.isClientSide);
+        MenuInventory newContainer = gamemode.getInventoryMenu(this.inventory);
         if (this.craftingInventory == this.inventorySlots) {
             this.craftingInventory = newContainer;
         }
         this.inventorySlots = newContainer;
-        if (!gamemode.canPlayerFly()) {
+        if (!gamemode.hasPlayerFlight()) {
             this.noPhysics = false;
         }
 
-        this.fireImmune = gamemode.isImmuneToFire();
+        this.fireImmune = gamemode.hasFireImmunity();
     }
 
     public void setGamemode(Gamemode gamemode) {
         this.gamemode = gamemode;
-        this.fireImmune = gamemode.isImmuneToFire();
+        this.fireImmune = gamemode.hasFireImmunity();
     }
 
     public void setNoclip(final boolean noclip) {
@@ -1439,7 +1479,7 @@ public abstract class Player
             return;
         }
 
-        if (pickFully && this.gamemode == Gamemode.creative && tileEntity != null) {
+        if (pickFully && this.gamemode == Gamemodes.CREATIVE && tileEntity != null) {
             CompoundTag entityTag = new CompoundTag();
             tileEntity.writeAdditionalData(entityTag);
             selectItem.getData().put("tileEntityData", entityTag);
@@ -1456,7 +1496,7 @@ public abstract class Player
 
         //Find empty hotbar slot
         int emptyHotbarSlot = -1;
-        int slot = this.inventory.getCurrentItemIndex();
+        int slot = this.inventory.getCurrentSlot();
         for (int i = 0; i < 9; i++) {
             if (this.inventory.getItem(i + this.inventory.getHotbarOffset()) == null) {
                 emptyHotbarSlot = i + this.inventory.getHotbarOffset();
@@ -1479,7 +1519,7 @@ public abstract class Player
         }
 
         if (itemSlot == -1) {
-            if (getGamemode() == Gamemode.creative) {
+            if (getGamemode() == Gamemodes.CREATIVE) {
                 int emptySlot = -1;
                 for (int i = 0; i < 36; i++) {
                     if (this.inventory.getItem(i) == null) {
@@ -1488,7 +1528,7 @@ public abstract class Player
                     }
                 }
 
-                int createItemInsertSlot = emptyHotbarSlot != -1 ? emptyHotbarSlot : this.inventory.getCurrentItemIndex();
+                int createItemInsertSlot = emptyHotbarSlot != -1 ? emptyHotbarSlot : this.inventory.getCurrentSlot();
                 selectItem.stackSize = 1;
                 if (emptySlot != -1) {
                     swapItems(emptySlot, createItemInsertSlot);
@@ -1505,7 +1545,7 @@ public abstract class Player
     }
 
     public void setCurrentItem(int i) {
-        this.inventory.setCurrentItemIndex(i, false);
+        this.inventory.setCurrentSlot(i, false);
     }
 
     public void swapItems(int slot1, int slot2) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index e2873835b..4decb46f8 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -10,7 +10,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.BlockParticleHelper;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
@@ -114,7 +114,7 @@ public class EntityBoat extends Entity {
             return true;
         }
         if (entity instanceof Player player) {
-            if (player.getGamemode() == Gamemode.creative) {
+            if (player.getGamemode() == Gamemodes.CREATIVE) {
                 remove();
                 if (this.flag != null) {
                     dropItem(this.flag.copy(), 0.0F);
@@ -445,7 +445,7 @@ public class EntityBoat extends Entity {
         if (!this.world.isClientSide) {
             if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.FLAG.id && this.flag == null) {
                 this.flag = player.getHeldItem().copy();
-                player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
+                player.inventory.setItem(player.inventory.getCurrentSlot(), null);
                 createTileEntity();
                 this.world.sendTrackedEntityDataPacket(this);
                 return true;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index 7d3ab1f45..2fb52e496 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -18,7 +18,7 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.InventorySorter;
 import net.minecraft.core.util.helper.DamageType;
@@ -224,7 +224,7 @@ public class EntityMinecart extends Entity implements Container {
             return true;
         }
         if (entity instanceof Player player) {
-            if (player.getGamemode() == Gamemode.creative) {
+            if (player.getGamemode() == Gamemodes.CREATIVE) {
                 remove();
                 return true;
             }
@@ -745,7 +745,7 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     @Override
-    public boolean stillValid(Player player) {
+    public boolean stillValid(@NotNull Player player) {
         if (isRemoved()) {
             return false;
         }
@@ -807,7 +807,7 @@ public class EntityMinecart extends Entity implements Container {
                 ItemStack itemstack = player.inventory.getCurrentItem();
                 if (itemstack != null && LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) > 0 && itemstack.consumeItem(player)) {
                     if (itemstack.stackSize <= 0) {
-                        player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
+                        player.inventory.setItem(player.inventory.getCurrentSlot(), null);
                     }
                     setFuel(getFuel() + MathHelper.round(((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) / 1600F) * 1200)));
                 }
@@ -873,7 +873,7 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     @Override
-    public String getNameTranslationKey() {
+    public @NotNull String getNameTranslationKey() {
         return "container.minecart.name";
     }
 
@@ -888,21 +888,21 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     @Override
-    public @Nullable ItemStack getItem(int index) {
-        return this.items[index];
+    public @Nullable ItemStack getItem(int slot) {
+        return this.items[slot];
     }
 
     @Override
-    public @Nullable ItemStack removeItem(int index, int takeAmount) {
-        if (this.items[index] != null) {
-            if (this.items[index].stackSize <= takeAmount) {
-                ItemStack itemstack = this.items[index];
-                this.items[index] = null;
+    public @Nullable ItemStack removeItem(int slot, int takeAmount) {
+        if (this.items[slot] != null) {
+            if (this.items[slot].stackSize <= takeAmount) {
+                ItemStack itemstack = this.items[slot];
+                this.items[slot] = null;
                 return itemstack;
             }
-            ItemStack itemstack1 = this.items[index].splitStack(takeAmount);
-            if (this.items[index].stackSize <= 0) {
-                this.items[index] = null;
+            ItemStack itemstack1 = this.items[slot].splitStack(takeAmount);
+            if (this.items[slot].stackSize <= 0) {
+                this.items[slot] = null;
             }
             return itemstack1;
         } else {
@@ -911,10 +911,10 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     @Override
-    public void setItem(int index, @Nullable ItemStack itemstack) {
-        this.items[index] = itemstack;
-        if (itemstack != null && itemstack.stackSize > getMaxStackSize()) {
-            itemstack.stackSize = getMaxStackSize();
+    public void setItem(int slot, @Nullable ItemStack stack) {
+        this.items[slot] = stack;
+        if (stack != null && stack.stackSize > getMaxStackSize()) {
+            stack.stackSize = getMaxStackSize();
         }
     }
 
@@ -923,7 +923,7 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     @Override
-    public void sortContainer() {
+    public void sort() {
         InventorySorter.sortInventory(this.items);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 252832a64..459d54675 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -68,7 +68,7 @@ public class ItemBucket extends Item {
                 block1.dropWithCause(world, EnumDropCause.WORLD, rayCastPos, world.getBlockData(rayCastPos), null, null);
             }
             world.setBlockIdDataNotify(rayCastPos, this.blockToPlace.id(), 0);
-            if (player.getGamemode().consumeBlocks()) {
+            if (player.getGamemode().hasBlockConsumption()) {
                 return new ItemStack(Items.BUCKET);
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
index c48450322..1904e2510 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
@@ -77,7 +77,7 @@ public class ItemBucketEmpty extends Item {
     public static boolean useBucket(@NotNull Player player, @NotNull ItemStack itemToGive) {
         ItemStack currentItem = player.inventory.getCurrentItem();
         if (currentItem == null || currentItem.stackSize <= 1) {
-            player.inventory.setItem(player.inventory.getCurrentItemIndex(), itemToGive);
+            player.inventory.setItem(player.inventory.getCurrentSlot(), itemToGive);
             return true;
         } else {
             player.inventory.insertItem(itemToGive, true);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
index 48d97f4e0..7d8e7d181 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -44,7 +44,7 @@ public class ItemDye extends Item {
         if (Block.hasLogicClass(block, BlockLogicSign.class) && world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
             if ((DyeColor.WHITE.itemMeta - selfStack.getMetadata()) != sign.getColor().id) {
                 sign.setColor(TextFormatting.get(DyeColor.WHITE.itemMeta - selfStack.getMetadata()));
-                if (player == null || player.getGamemode().consumeBlocks()) {
+                if (player == null || player.getGamemode().hasBlockConsumption()) {
                     selfStack.stackSize--;
                 }
                 return true;
@@ -67,7 +67,7 @@ public class ItemDye extends Item {
                             grass = Blocks.GRASS_RETRO.id();
                         }
                         world.setBlockIdNotify(blockPos, grass);
-                        if (player == null || player.getGamemode().consumeBlocks()) {
+                        if (player == null || player.getGamemode().hasBlockConsumption()) {
                             selfStack.stackSize--;
                         }
                     }
@@ -79,7 +79,7 @@ public class ItemDye extends Item {
                     if (Blocks.lightBlock[world.getBlockId(blockPos.up(queryPos))] <= 2) {
                         int grass = Blocks.GRASS_SCORCHED.id();
                         world.setBlockIdNotify(blockPos, grass);
-                        if (player == null || player.getGamemode().consumeBlocks()) {
+                        if (player == null || player.getGamemode().hasBlockConsumption()) {
                             selfStack.stackSize--;
                         }
                     }
@@ -89,7 +89,7 @@ public class ItemDye extends Item {
 
             if (block != null && block.hasTag(BlockTags.GROWS_FLOWERS)) {
                 if (!world.isClientSide) {
-                    if (player == null || player.getGamemode().consumeBlocks()) {
+                    if (player == null || player.getGamemode().hasBlockConsumption()) {
                         selfStack.stackSize--;
                     }
                     TilePos p = new TilePos(blockPos);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
index f1327289c..b2ec41d87 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
@@ -85,7 +85,7 @@ public class ItemJar extends ItemPlaceable {
     public static boolean fillJar(@NotNull Player player, @NotNull ItemStack itemToGive) {
         ItemStack currentItem = player.inventory.getCurrentItem();
         if (currentItem == null || currentItem.stackSize <= 1) {
-            player.inventory.setItem(player.inventory.getCurrentItemIndex(), itemToGive);
+            player.inventory.setItem(player.inventory.getCurrentSlot(), itemToGive);
         } else {
             player.inventory.insertItem(itemToGive, true);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
index 0b0898cc4..971180231 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
@@ -33,7 +33,7 @@ public class ItemMinecart extends Item {
         if(!world.isClientSide) {
             world.entityJoinedWorld(new EntityMinecart(world, (float) blockPos.x() + 0.5F, (float) blockPos.y() + 0.5F, (float) blockPos.z() + 0.5F, this.minecartType));
         }
-        if (player == null || player.getGamemode().consumeBlocks()) {
+        if (player == null || player.getGamemode().hasBlockConsumption()) {
             selfStack.stackSize--;
         }
         return true;
